# This program is used to turn a device on (or off) depending on:
#   1 - the current hour is in the listOfHour array
#   2 - the current minute is in the listOfMinutes array
#
# If both the previous are true, the relay is opened (set to HIGH) for 70 seconds
# Loops indefinitely until Ctrl-C is pressed

import RPi.GPIO as GPIO
import time
from datetime import datetime
GPIO.setmode(GPIO.BCM)
GPIO.setup(17, GPIO.OUT)
GPIO.output(17, GPIO.LOW) #turn the power off!
try:
    print("running ...")
    while(True):
      #reset myObj value each time around
      myObj = datetime.now()
      current_date_and_time = myObj
      # Populate the following array with the hours you want to reset the power
      #listOfHours = [0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23]
      listOfHours = [1, 4, 7, 10, 13, 16, 19, 23]
      curHour = myObj.hour
      #list of hours
      contains_hour = curHour in listOfHours
      if contains_hour==True :
          # current hour is in the list of hours
          curMinute = myObj.minute
	  #Populate the following array with the minutes at which you want to reset the power
	  #listOfMinutes = [27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 00, 05, 10, 15, 20, 25, 30, 35, 40, 45, 50, 55]
          #listOfMinutes = [00, 05, 10, 15, 20, 25, 30, 35, 40, 45, 50, 55]
	  #listOfMinutes = [00, 15, 30, 45]
          listOfMinutes = [1]
          contains_minute = curMinute in listOfMinutes
          if contains_minute==True :
              print("Hour " + str(curHour) + " Minute " + str(curMinute))
              # Turn off power to litterrobot
              # Because relay is wired in NO (Normally On) mode,
              # setting to HIGH closes the relay and turns power to robot off
              print('Power OFF/Relay ON' + str(current_date_and_time))
              GPIO.output(17, GPIO.HIGH) #closes relay which turns power off
              time.sleep(62)  #sleep for 62 seconds #gets past the current minute
              print('Power ON/Relay OFF - ' + str(current_date_and_time))
              GPIO.output(17, GPIO.LOW)  # turn relay off to establish power to robot
      time.sleep(30)

finally:
    GPIO.cleanup()